#include <string.h>
#include "person.h"


void swap_persons(person_t *jack, person_t *jill)
{
    person_t  t;

    t = *jack;  *jack = *jill;  *jill = t;
} /* swap_persons */


void sort_persons_id(person_t* ps, int len)
{
    int sorted;    /* already sorted until this index */
    int tail_mini; /* Index of minimum from sorted to the end */

    sorted = 0;    /* Nothing is sorted yet */
    while (sorted < len)
    {
        int  j;

        tail_mini = sorted;
        j = tail_mini + 1;
        while (j < len)
        {
            if (ps[tail_mini].numeric_id > ps[j].numeric_id)
            {
                tail_mini = j;
            }
            j++;
        }

        /* swap so a[sorted] will get the minimum of the tail */
        swap_persons(&ps[sorted], &ps[tail_mini]);
        sorted++;
    }
} /* sort_persons_id */


void sort_persons_name(person_t* ps, int len)
{
    int sorted;    /* already sorted until this index */
    int tail_mini; /* Index of minimum from sorted to the end */

    sorted = 0;    /* Nothing is sorted yet */
    while (sorted < len)
    {
        int  j;

        tail_mini = sorted;
        j = tail_mini + 1;
        while (j < len)
        {
            if (strcmp(ps[tail_mini].name, ps[j].name) > 0)
            {
                tail_mini = j;
            }
            j++;
        }

        /* swap so a[sorted] will get the minimum of the tail */
        swap_persons(&ps[sorted], &ps[tail_mini]);
        sorted++;
    }
} /* sort_persons_name */


void sort_persons_weight(person_t* ps, int len)
{
    int sorted;    /* already sorted until this index */
    int tail_mini; /* Index of minimum from sorted to the end */

    sorted = 0;    /* Nothing is sorted yet */
    while (sorted < len)
    {
        int  j;

        tail_mini = sorted;
        j = tail_mini + 1;
        while (j < len)
        {
            if (ps[tail_mini].weight > ps[j].weight)
            {
                tail_mini = j;
            }
            j++;
        }

        /* swap so a[sorted] will get the minimum of the tail */
        swap_persons(&ps[sorted], &ps[tail_mini]);
        sorted++;
    }
} /* sort_persons_weight */


void sort_persons(person_t* ps, int np, sort_key_t sort_key)
{
    /* Expression inside switch (parentheis) must be  int  or  enum value */
    switch (sort_key)
    {
     /* Cases must be given _constants_ ! */
     case SORT_KEY_ID:
        sort_persons_id(ps, np);
        break;
     case SORT_KEY_NAME:
        sort_persons_name(ps, np);
        break;
     case SORT_KEY_WEIGHT:
        sort_persons_weight(ps, np);
        break;
    }
} /* sort_persons */
